# DLL

Infinite8 device library for use in SDKs

# Version 1.0

This vesion only works with Fascin8 firmware2.1 and Ultim8 firmware1.5

# I8DeviceDLL

I8DeviceDLL is a library package for a 3rd party to be able make use of Infinite8 Devices without any desctop application.
There is some classes and methodes in this dll file for users to minimize complexiti of hardware protocols.
With this pakage users can easily connect to any Infinite8 devices from many programming languege including C++, matlab and python.

## Getting Started (python)

This dll requires the following packages to work with.

### Prerequisites

 Use [Python for .NET](http://pythonnet.github.io/) to install "clr" package for connect dll to python.

### Import dll file

After installing the requrment packages, import ".net for python" (clr) and make a reference (copy) of the .dll file with thess commands: 

```
import clr
clr.AddReference(the absolute path of i8.dll file)
# for example: clr.AddReference('C:/Users/i8-tech/Desktop/csharp_dlls/infinite8dll/I8Library1/bin/Debug/I8Library1.dll')
```
### Instance from main class of i8devices
Just import `Device` class, And then you can use it by declaring an instance of `Device` class.
```
from I8Devices import Device, Settings
myAwsomeHolyShitImDyingForThisDevice = Device()

```
## How to Use

First of all, you should plug your device into your PC, and also install `ST micro COM Port Package` from `Device Manager` (it should be installed itself whenever you be connected to the internet).
After that type in the `Connect` method   

```
myAwsomeHolyShitImDyingForThisDevice.Connect()

```
This method also return a boolian "True/False" to indicate whether the device is successfully connected to the PC or not. 
If device is successfully connected to the PC, you can use the following methods and properties to retrieve Device information, or send a command/ recieve data to/from the device:

```
# Info
    myAwsomeHolyShitImDyingForThisDevice.getInfo()
    myAwsomeHolyShitImDyingForThisDevice.getStatus()

# get data
   myAwsomeHolyShitImDyingForThisDevice.start()
   myAwsomeHolyShitImDyingForThisDevice.stop()
   myAwsomeHolyShitImDyingForThisDevice.getData()

```
### Methodes
#### getInfo()
If you call this method without any input or with input `all`, it will return a dict with this structure:
{'name':String, 'version':String, 'id':String, 'flash':String}
Or you can just call this method with one above keys, so it will return just an string.
```
myAwsomeHolyShitImDyingForThisDevice.getInfo('version')

```
#### getStatus()
If you call this method without any input or with input `all`, it will return a dict with this structure:
{'mode':Bool, 'cnt':Int, 'buff_len':Int}
Or you can just call this method with one above keys.
```
myAwsomeHolyShitImDyingForThisDevice.getStatus('cnt')

```
mode: If 'True' indicates that "device is busy (in gathering mode)". If false indicates that "device is idle (not in gathering mode)".
cnt: Number of all sample that device send to pc since calling last `start` method.
buff_len: Number of samples that are stored in buffer but not been read yet.

#### start()
Right after calling this method, the device will go in 'gathering mode' and start to acquire data.
#### stop()
Right after calling this method, the device will stop acquiring data.
#### getData()
This method gives you an amount of "gathered samples" depend on where and when you call it.

If you call this method with no input in the middle of data gathering, it will return all of buffer 
and if buffer is empty it will wait untill at least one sample arrives.

If you call this method with a number of samples you want (n), in the middle of data gathering, it will return the very last n samples 
of buffer and if samples in buffer are less than 'n', it will wait until length of buffer be equal to 'n'.

Note that this method will remove all of buffer after return.

### Setting
For changing settings of the device you should create an instance of class `Settings` 
```
    mysetting = Settings()
    mysetting.test_signal = True
    mysetting.sampling_rate = 2000
    mysetting.channels_on[7] = False
    mysetting.gain = 24
    print(myAwsomeHolyShitImDyingForThisDevice.writeSetting(mysetting))

```
    
## Built With
* [C# dll .net](https://docs.microsoft.com/en-us/dotnet/api/system.io.ports.serialport.pinchanged?view=netframework-4.8)
* [numpy](https://pypi.org/project/numpy/) - Used to calculate some shit
* [scipy](https://pypi.org/project/scipy/) - Used to calculate some real shit

## Contributing

No contribution.

### Pull Request Process

1. Ensure any install or build dependencies are removed before the end of the layer when doing a 
   build.
2. Update the README.md with details of changes to the interface, this includes new environment 
   variables, exposed ports, useful file locations and container parameters.
3. Increase the version numbers in any examples files and the README.md to the new version that this
   Pull Request would represent. The versioning scheme we use is [SemVer](http://semver.org/).
4. You may merge the Pull Request in once you have the sign-off of two other developers, or if you 
   do not have permission to do that, you may request the second reviewer to merge it for you.

## Versioning

We use [SemVer](http://semver.org/) for versioning. The current released version is 0.2.5.

## Authors

* **Varnos** - *Initial work* - [Varnos](http://51.75.64.148/reza)

## License

This project is licensed under the I8 Co. License - see the [Infinite8 website](https://infinite8.tech) for details. (you wish there will be some information but I gotta tell you there is not )